<?xml version="1.0" encoding="utf-8"?>

<!--

This stylesheet convert a gw.properties from a gateway version of 3.0.3 to
version 3.0.4. To do so:

If sip.contactHostName missing, add and set value automatic-hostname.

-->

<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method = "xml" indent = "yes" /> 

<!-- This template copy all the elements and their attributes -->
<xsl:template match="node()|@*">
  <xsl:copy>
    <xsl:apply-templates select="node()|@*"/>
  </xsl:copy>
</xsl:template>

 
<!-- 
If sip.contactHostName is not defined set it to automatic hostname
since this is the default behavior of gateway 3.0.3.
-->
<xsl:template match="sip/contactHostName[@defined='false']">
  <xsl:copy>
    <xsl:apply-templates select="node()|@*"/>
    <xsl:attribute name="value">automatic-hostname</xsl:attribute>
    <xsl:attribute name="defined">true</xsl:attribute>
  </xsl:copy>
</xsl:template>


</xsl:stylesheet> 
