<?xml version="1.0" encoding="utf-8"?>

<!--

This stylesheet convert a oamWebServer.properties from a gateway version to the
installed version. To do so:

Set the following parameters,

netborder.oamWebServer.gwVersion=$dstVersion

$dstVersion is passed by the converter and represents the installed gw version.
-->

<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method = "xml" indent = "yes" /> 

<!-- This template copy all the elements and their attributes -->
<xsl:template match="node()|@*">
  <xsl:copy>
    <xsl:apply-templates select="node()|@*"/>
  </xsl:copy>
</xsl:template>

<xsl:template match="netborder/oamWebServer">
  <xsl:variable name="count" select="count(descendant-or-self::gwVersion)"/>
  <xsl:copy>   
    <xsl:apply-templates select="@*"/>
    <xsl:if test="$count = 0">
      <xsl:element name="gwVersion">
        <xsl:attribute name="value">
           <xsl:value-of select="$dstVersion"/>
        </xsl:attribute>
        <xsl:attribute name="defined">true</xsl:attribute>
      </xsl:element>
    </xsl:if>
    <xsl:apply-templates/>
  </xsl:copy>
</xsl:template>

<xsl:template match="netborder/oamWebServer/gwVersion">
  <xsl:copy>   
    <xsl:attribute name="value">
      <xsl:value-of select="$dstVersion"/>
    </xsl:attribute>
    <xsl:attribute name="defined">true</xsl:attribute>
    <xsl:apply-templates/>
  </xsl:copy>
</xsl:template>

</xsl:stylesheet> 

