<?xml version="1.0" encoding="utf-8"?>

<!--

This stylesheet convert a pstn-config from a gateway version of 4.0.0 to version
4.0.1. To do so:

-Xml version need to be changed to 3.1
  Gateway 4.0.0 -> pstn-config 3.0
  Gateway 4.0.1 -> pstn-config 3.1

-Attribute callerNameLocation must be set to it's new corresponding value
  IN-SETUP-MSG -> IN-SETUP-MSG-USING-DISPLAY-IE
  IN-FACILITY-MSG -> IN-FACILITY-MSG-USING-FACILITY-IE

-->

<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method = "xml" indent = "yes" /> 


<!-- This template copy all the elements and their attributes -->
<xsl:template match="node()|@*">
  <xsl:copy>
    <xsl:apply-templates select="node()|@*"/>
  </xsl:copy>
</xsl:template>


<!-- Set pstnConfig version to 3.1 -->
<xsl:template match="pstnConfig">
  <xsl:copy>
    <xsl:apply-templates select="@*"/>
    <xsl:attribute name="version">3.1</xsl:attribute>
    <xsl:apply-templates select="node()"/>
  </xsl:copy>
</xsl:template>

<!-- 
If callerNameLocation is IN-SETUP-MSG set it to 
IN-SETUP-MSG-USING-DISPLAY-IE 
If callerNameLocation is IN-FACILITY-MSG set it to 
IN-FACILITY-MSG-USING-FACILITY-IE
-->
<xsl:template match="fasConfig|nfasGroup|briConfig">
  <xsl:copy>
    <xsl:apply-templates select="@*"/>
    <xsl:choose>
      <xsl:when test="@callerNameLocation='IN-SETUP-MSG'">
        <xsl:attribute name="callerNameLocation">IN-SETUP-MSG-USING-DISPLAY-IE</xsl:attribute>
      </xsl:when>
      <xsl:when test="@callerNameLocation='IN-FACILITY-MSG'">
        <xsl:attribute name="callerNameLocation">IN-FACILITY-MSG-USING-FACILITY-IE</xsl:attribute>
      </xsl:when>
    </xsl:choose>
    <xsl:apply-templates/>
  </xsl:copy>
</xsl:template>

</xsl:stylesheet> 
