#!/bin/sh
#
# This script builds and rpm package that lets user install 
# the Sangoma drivers for the netborder-gateway
#
WITH_LINUX_OP="NO";
while [ ! -z "$1" ]; 
  do
   ARGS_tmp=$ARGS"$1 "
   ARGS=$ARGS_tmp
   shift
  done
  echo "Arguments: $ARGS"

for arg in $ARGS
  do
    case $arg in

	--with-linux*)
              SOURCEDIR=`echo $arg | cut -d'=' -f2`;
              if [[ "$SOURCEDIR" = "" ]]; then
                echo "Error invalied --with-linux option";
                exit 1;
		fi
		if [[ ! -d "$SOURCEDIR" ]]; then
		  echo "Error: Linux source directory not found: $SOURCEDIR";
		  exit 1;
		fi
		if [[ ! -f "$SOURCEDIR/Makefile" ]]; then
		  echo "Error: No vaild linux source found in $SOURCEDIR";
		  exit 1;
		fi
		WITH_LINUX_OP="YES";
		;;

	*)
	  echo "Invalid option $arg"
	  exit 1;
	  ;;
	esac
  done

if [[ $SANGOMA_DRV_RPM_BUILD_ROOT ]] ; then
  kernel_version=$(uname -r)
  # generate Sangoma drivers rpm package using the provided build root
  /usr/bin/rpmbuild -bb --buildroot $SANGOMA_DRV_RPM_BUILD_ROOT XXX_INSTDIR_XXX/drivers/rpm/wanpipe.rpmspec --define "kern_ver $kernel_version"
else
  pushd XXX_INSTDIR_XXX/drivers/wanpipe
  # generate Sangoma drivers rpm package
  kernel_platform=`uname -i`
  if [[ $WITH_LINUX_OP == YES ]]; then
    ./Setup buildrpm  --with-linux=$SOURCEDIR --arch=$kernel_platform --protocol=AFT_TE1 --silent
  else
    ./Setup buildrpm  --arch=$kernel_platform --protocol=AFT_TE1 --silent
  fi
  popd
fi
