import os
import sys
import subprocess
from subprocess import mswindows
import turbogears
from turbogears import controllers, expose
from turbogears import flash, redirect, url
import logging
from paraxip.gateway_gui import extjs
import simplejson

log = logging.getLogger("hwprobe")

class HardwareProbeController(controllers.Controller):
    #@expose(template='kid:pstnconfig.templates.help.help')
    #def index (self):
    #    """Displays the output of a wanrouter hwprobe command"""
    #    return {}
    @expose()
    def getHardwareStatus(self):
        log.info("Getting hardware Status. ")
        data = []
        out_str = "<html><body>"
        try:
            if os.name == 'posix':
                log.debug( "posix OS" )
                stdWanrouterCmd = "wanrouter"
            else:
                log.debug( "Windows OS" )
                stdWanrouterCmd = "c:\windows\system32\wanrouter.exe"

            #wanrouter reset_port_numbers
            currentCmd = stdWanrouterCmd
            currentCmd += " "
            currentCmd += "reset_port_numbers"
            log.info( "running command: %s" % currentCmd)

            resetProcess = \
                        subprocess.Popen(args=[stdWanrouterCmd,'reset_port_numbers'],
                                         stdout=subprocess.PIPE,
                                         stdin=subprocess.PIPE,
                                         stderr=subprocess.PIPE)
            output = resetProcess.communicate()
            log.debug( "stdout[%s]. stderr[%s]"%(output[0], output[1]) )
            if  resetProcess.returncode != 0:
                log.error("failed to execute command %s" % (currentCmd))
                return (str(extjs.FormActionLoadResponse(success=False, data=data)))

            data.append({'reset_port_numbers': output[0]})

            out_str += "reset_port_numbers command output: <br>"
            res = output[0].split('\n')
            for s in res:
                out_str += "%s<br>" % s

            #wanrouter list
            currentCmd = stdWanrouterCmd
            currentCmd += " "
            currentCmd += "list"
            log.info( "running command: %s" % currentCmd)

            listProcess = \
                        subprocess.Popen(args=[stdWanrouterCmd,'list'],
                                         stdout=subprocess.PIPE,
                                         stdin=subprocess.PIPE,
                                         stderr=subprocess.PIPE)
            output = listProcess.communicate()
            log.debug( "stdout[%s]. stderr[%s]"%(output[0], output[1]) )
            if  listProcess.returncode != 0:
                log.error("failed to execute command %s" % (currentCmd))
                return (str(extjs.FormActionLoadResponse(success=False, data=data)))

            data.append({'list': output[0]})
            ls = output[0].split('\n')
            out_str += "list command output: <br>"
            for s in ls:
                out_str += "%s <br>" % s


            #wanrouter hwprobe
            currentCmd = stdWanrouterCmd
            currentCmd += " "
            currentCmd += "hwprobe"
            log.info( "running command: %s" % currentCmd)

            hwprobeProcess = \
                        subprocess.Popen(args=[stdWanrouterCmd,'hwprobe'],
                                         stdout=subprocess.PIPE,
                                         stdin=subprocess.PIPE,
                                         stderr=subprocess.PIPE)
            output = hwprobeProcess.communicate()
            log.debug( "stdout[%s]. stderr[%s]"%(output[0], output[1]) )
            if  hwprobeProcess.returncode != 0:
                log.error("failed to execute command %s" % (currentCmd))
                return (str(extjs.FormActionLoadResponse(success=False, data=data)))

            data.append({'hwprobe': output[0]})

            probe = output[0].split('\n')

            out_str += "hwprobe command output: <br>"
            for s in probe:
                out_str += "%s<br>" % s
            
        except:
            log.error("failed to execute command %s; e=%s" % (currentCmd,sys.exc_info()[0]))
            return (str(extjs.FormActionLoadResponse(success=False, data=data)))
        out_str += "</html></body>"
        return out_str

